using BeachOrder.Helpers;
using System;
using System.Web;

namespace BeachOrder.ActionFilters
{
    public class LisansFilter : System.Web.Mvc.AuthorizeAttribute
    {
        protected override bool AuthorizeCore(HttpContextBase httpContext)
        {
            //Kullanıcı giriş yapmamışsa login sayfasına at
            if (!LisansProccess())
            {
                httpContext.Response.Redirect("~/Error/License");
                return false;
            }
            else
            {
                return true;
            }
        }
        bool LisansProccess()
        {
            //return Helpers.Helpers.LisansOku();
            var result = (object)System.Runtime.Caching.MemoryCache.Default["lisans"];
            // henuz memde bişey yoksa
            if (result == null)
            {
                // db den oku ve lisansız ise
                var lisansResult = Helpers.Helpers.LisansOku();
                if (lisansResult == Models.Lisans.Lisanssiz)
                {
                    System.Runtime.Caching.MemoryCache.Default.Add("lisans", Models.Lisans.Lisanssiz, DateTimeOffset.Now.AddDays(1));
                    return false;
                }
                else
                {
                    // lisanslı ise cache e 15 gün süre için yaz;
                    System.Runtime.Caching.MemoryCache.Default.Add("lisans", Models.Lisans.Lisanssiz, DateTimeOffset.Now.AddDays(15));
                    return true;
                }
            }
            // memory de bişeyler var
            else
            {
                if (result.ToSafeString() == Models.Lisans.Lisansli.ToSafeString())
                {
                    return true;
                }
                else if (result.ToSafeString() == Models.Lisans.Lisanssiz.ToSafeString())
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
        }
    }
}